//+------------------------------------------------------------------+
//|                                                  abin's Macd.mq4 |
//+------------------------------------------------------------------+

/*
һʾMACDֵָӦߵͼ۸ָ꣬
ָԭǰ߸ߵ㣨͵㣩ڣڣǰһߵĸߵ㣨͵㣩
fast emaMACDеĿƽߣ

һKDͨÿʵ˫ָָıʾ
*/   
#property copyright "Copyright 2009,ǵ(abin)"
#property link      "msn:abin_kong@hotmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_width1 1
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width2 1

extern string TimeFrame = "Current time frame";
extern int fema =  12; 
extern int sema =    26;
extern int msma =  9; 
extern int k =  26; 
extern int d =  12;
extern int s =  9; 
extern double KDlevel= 30;//ˮƽ
extern bool VoiceAlert = false;
extern bool MACDfilter  = true;
extern bool KDfilter = true;


double CrossUp[];
double CrossDown[];
string indicatorFileName;
int    timeFrame;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars"; if (returnBars) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
ObjectsDeleteAll(0,OBJ_LABEL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int setalert=0,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (timeFrame!=Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for(int i = limit; i >= 0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         int x = iBarShift(NULL,timeFrame,Time[i+1]);
            if (x!=y)
            {
               CrossUp[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",fema,sema,msma,k,d,s,KDlevel,VoiceAlert,MACDfilter,KDfilter,0,y);
               CrossDown[i] = iCustom(NULL,timeFrame,indicatorFileName,"",fema,sema,msma,k,d,s,KDlevel,VoiceAlert,MACDfilter,KDfilter,1,y);
            }
            else
            {
               CrossUp[i]   = EMPTY_VALUE;
               CrossDown[i] = EMPTY_VALUE;
            }
       }
       return(0);
   }

   //
   //
   //
   //
   //
                
   for(i = limit; i >= 0; i--) 
   {
      double AvgRange=0;
         for (int counter=i;counter<=i+9;counter++) AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      double Range=AvgRange/10;
       
      double k1now           = iStochastic(NULL, 0, k,d,s,MODE_EMA,0,0, i);
      double k1previous      = iStochastic(NULL, 0, k,d,s,MODE_EMA,0,0, i+1);
      double main1now        = iMACD(NULL, 0, fema,sema,msma, PRICE_LOW,0, i);
      double main1previous   = iMACD(NULL, 0, fema,sema,msma, PRICE_LOW,0, i+1);
      double signal1now      = iMACD(NULL, 0, fema,sema,msma, PRICE_LOW,1, i);
      double signal1previous = iMACD(NULL, 0, fema,sema,msma, PRICE_LOW,1, i+1);
      double main2now        = iMACD(NULL, 0, fema,sema,msma, PRICE_HIGH,0, i);
      double main2previous   = iMACD(NULL, 0, fema,sema,msma, PRICE_HIGH,0, i+1);
      double signal2now      = iMACD(NULL, 0, fema,sema,msma, PRICE_HIGH,1, i);
      double signal2previous = iMACD(NULL, 0, fema,sema,msma, PRICE_HIGH,1, i+1);
      double ma1now          = iMA(NULL,0,fema,0,1,PRICE_CLOSE,i);
      double d1now           = iStochastic(NULL, 0, k,d,s,MODE_EMA,0,1, i);
      double d1previous      = iStochastic(NULL, 0, k,d,s,MODE_EMA,0,1, i+1);
      
      if (MACDfilter==true&&KDfilter==true)
         {
         if((Low[i]<Low[i+1])&& (k1now<KDlevel)&&(Low[i]<ma1now)&&
            (k1now > k1previous) && (d1now > d1previous) && 
            (main1now > main1previous) && (signal1now > signal1previous) && (main1now<0))
               {
                   CrossUp[i] = Low[i] - Range*0.5;            
                   if (VoiceAlert==true && setalert==0)
                     {
                     Alert(Symbol(),"Ѷ");
                     PlaySound("upsignal.wav");  //Զļ
                     setalert=1;
                     }
               }
               
          if((High[i]>High[i+1])&& (k1now>(100-KDlevel))&& (High[i]>ma1now)&&
             (k1now < k1previous) && (d1now < d1previous) &&
             (main2now < main2previous) && (signal2now < signal2previous)&&(main2now>0))
                {
                     CrossDown[i] = High[i] + Range*0.5;
                     if (VoiceAlert==true && setalert==0)
                       {
                       Alert(Symbol(),"Ѷ");  
                       PlaySound("downsignal.wav");
                       setalert=1;
                        }
                }
          }
//----macd on kd off        
      if (MACDfilter==true&&KDfilter==false)
         {
         if((Low[i]<Low[i+1])&& (k1now<KDlevel)&&(Low[i]<ma1now)&&
            //(k1now > k1previous) && (d1now > d1previous) && 
            (main1now > main1previous) && (signal1now > signal1previous) && (main1now<0))
               {
                   CrossUp[i] = Low[i] - Range*0.5;            
                   if (VoiceAlert==true && setalert==0)
                     {
                     Alert(Symbol(),"Ѷ");
                     PlaySound("upsignal.wav");  //Զļ
                     setalert=1;
                     }
               }
               
          if((High[i]>High[i+1])&& (k1now>(100-KDlevel))&& (High[i]>ma1now)&&
             //(k1now < k1previous) && (d1now < d1previous) &&
             (main2now < main2previous) && (signal2now < signal2previous)&&(main2now>0))
                {
                     CrossDown[i] = High[i] + Range*0.5;
                     if (VoiceAlert==true && setalert==0)
                       {
                       Alert(Symbol(),"Ѷ");  
                       PlaySound("downsignal.wav");
                       setalert=1;
                        }
                }
          }
//----macd off kd on        
      if (MACDfilter==false&&KDfilter==true)
         {
         if((Low[i]<Low[i+1])&& (k1now<KDlevel)&&(Low[i]<ma1now)&&
            (k1now > k1previous) && (d1now > d1previous))// && 
            //(main1now > main1previous) && (signal1now > signal1previous) && (main1now<0))
               {
                   CrossUp[i] = Low[i] - Range*0.5;            
                   if (VoiceAlert==true && setalert==0)
                     {
                     Alert(Symbol(),"Ѷ");
                     PlaySound("upsignal.wav");  //Զļ
                     setalert=1;
                     }
               }
               
          if((High[i]>High[i+1])&& (k1now>(100-KDlevel))&& (High[i]>ma1now)&&
             (k1now < k1previous) && (d1now < d1previous))// &&
             //(main2now < main2previous) && (signal2now < signal2previous)&&(main2now>0))
                {
                     CrossDown[i] = High[i] + Range*0.5;
                     if (VoiceAlert==true && setalert==0)
                       {
                       Alert(Symbol(),"Ѷ");  
                       PlaySound("downsignal.wav");
                       setalert=1;
                        }
                }
          }
//----                       
}          
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   ts = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(ts, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     ts = StringSetChar(ts, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     ts = StringSetChar(ts, length, tchar + 224);
   }
   return(ts);
}